#include <stdlib.h>
#include <stdio.h>
#include <cogent.h>

#include "trenddb.h"

int interpolate_data  ( IP_Task *myself, IP_Task *hist,
						char *hist_name, double t_beg, double t_end,
						pt_t **values, int *nvalues)
{
	char			data [512];
	int				len;
	pt_t			*ptbuf;
	int				ptlen;
	int				i;
	int				step;
	int				count;
	int				offset;
	int				bufid = 0;
	int				ret;
	IP_Msg 			*smsg, *rmsg;

	smsg = IP_MsgCreate (NULL, IP_MsgDefaultSize(), 0);
	rmsg = IP_MsgCreate (NULL, IP_MsgDefaultSize(), 0);

	ret = 0;
	len = sprintf (data, "interpolate %f %f %s", t_beg, t_end, hist_name) + 1;
	IP_MsgCascade (smsg, data, len, IP_NONE, ST_OK);
	if (IP_TaskSendSync (myself, hist, smsg, rmsg) == 0) {
		if (!strcmp ((char*) rmsg->msg->data, "ERROR")) {
			printf ("interpolate reply: %s\n", (char*) rmsg->msg->data);
			ret = -1;
		} else {
			sscanf ((char*) rmsg->msg->data, "%d", &bufid);
		}
	} else {
		printf ("interpolate rmsg \"%s\", bufid = %d\n", (char*) rmsg->msg->data, bufid);
		perror ("");
		ret = -1;
	}
		
	ptlen = 0;
	len = sprintf (data, "buffer_id_lenght %d", bufid) + 1;
	IP_MsgCascade (smsg, data, len, IP_NONE, ST_OK);
	if (IP_TaskSendSync (myself, hist, smsg, rmsg) == 0) {
		if (!strcmp ((char*) smsg->msg->data, "ERROR")) {
			printf ("buffer_id_lenght reply: %s\n", (char*) rmsg->msg->data);
			ret = -1;
		} else {
			sscanf ((char*) rmsg->msg->data, "%d", &ptlen);
		}
	}
	
	ptbuf = malloc (ptlen * sizeof (pt_t));
	for (i= 0, step= 30; i< ptlen; i+= step) {
		count = min (step, (ptlen - i));
		offset = i;
		len = sprintf (data, "buffer_id_read %d %d %d", bufid, offset, count) + 1;
		IP_MsgCascade (smsg, data, len, IP_NONE, ST_OK);
		if (IP_TaskSendSync (myself, hist, smsg, rmsg) == 0) {
			if (strcmp ((char*) rmsg->msg->data, "ERROR")) {
				memcpy (&ptbuf [offset], rmsg->msg->data, rmsg->msg->nbytes);
			} else {
				printf ("buffer_id_read reply: %s\n", (char*) rmsg->msg->data);
				ret = -1;
			}
		}
	}

//	printf ("%s, ptlen = %d\n", hist_name, ptlen);
	
	len = sprintf (data, "buffer_id_destroy %d", bufid) + 1;
	IP_MsgCascade (smsg, data, len, IP_NONE, ST_OK);
	if (IP_TaskSendSync (myself, hist, smsg, rmsg) == 0) {
		if (!strcmp ((char*) rmsg->msg->data, "ERROR")) {
			printf ("bufid reply: %s\n", (char*) rmsg->msg->data);
			ret = -1;
		}
	}
	
	*values = ptbuf;
	*nvalues = ptlen;	
	
	IP_MsgDestroy (smsg);
	IP_MsgDestroy (rmsg);
	
	return ret;
}